﻿' Copyright Brandan Tyler Lasley 2014 http://brandanlasley.com 
Imports System.IO
Imports System.Xml

Public Class Form1
    Structure ObjEditObjectsInfo ' 54 bytes
        Dim flags As System.UInt16
        Dim NumFaces As System.Int16
        Dim NumPoints As System.Int16
        Dim BucketOffSet As System.SByte
        Dim SeqNum As System.SByte
        Dim EditorScale As System.Int32
        Dim Scale As System.Int32
        Dim StartFace As System.UInt32
        Dim EndFace As System.UInt32
        Dim StartPoint As System.UInt32
        Dim EndPoint As System.UInt32
        Dim ScaledMinsX As System.Int16
        Dim ScaledMinsY As System.Int16
        Dim ScaledMinsZ As System.Int16
        Dim ScaledMaxsX As System.Int16
        Dim ScaledMaxsY As System.Int16
        Dim ScaledMaxsZ As System.Int16
        Dim ShapeIdx As List(Of SByte) ' 4!
        Dim ScaledOffSetsX As System.Int16
        Dim ScaledOffSetsY As System.Int16
        Dim ScaledOffSetsZ As System.Int16
    End Structure

    Private Sub NewToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles NewToolStripMenuItem.Click
        Try
            Dim TABPG As New TabPage
            Dim DGV As New DataGridView

            DGV.Dock = DockStyle.Fill
            DGV.Columns.Add("Flags", "Flags")
            DGV.Columns.Add("NumFaces", "NumFaces")
            DGV.Columns.Add("NumPoints", "NumPoints")
            DGV.Columns.Add("BucketOffSet", "BucketOffSet")
            DGV.Columns.Add("SeqNum", "SeqNum")
            DGV.Columns.Add("EditorScale", "EditorScale")
            DGV.Columns.Add("Scale", "Scale")
            DGV.Columns.Add("StartFace", "StartFace")
            DGV.Columns.Add("EndFace", "EndFace")
            DGV.Columns.Add("StartPoint", "StartPoint")
            DGV.Columns.Add("EndPoint", "EndPoint")
            DGV.Columns.Add("ScaledMinsX", "ScaledMinsX")
            DGV.Columns.Add("ScaledMinsY", "ScaledMinsY")
            DGV.Columns.Add("ScaledMinsZ", "ScaledMinsZ")
            DGV.Columns.Add("ScaledMaxsX", "ScaledMaxsX")
            DGV.Columns.Add("ScaledMaxsY", "ScaledMaxsY")
            DGV.Columns.Add("ScaledMaxsZ", "ScaledMaxsZ")
            DGV.Columns.Add("ShapeIdx1", "ShapeIdx1")
            DGV.Columns.Add("ShapeIdx2", "ShapeIdx2")
            DGV.Columns.Add("ShapeIdx3", "ShapeIdx3")
            DGV.Columns.Add("ShapeIdx4", "ShapeIdx4")
            DGV.Columns.Add("ScaledOffSetsX", "ScaledOffSetsX")
            DGV.Columns.Add("ScaledOffSetsY", "ScaledOffSetsY")
            DGV.Columns.Add("ScaledOffSetsZ", "ScaledOffSetsZ")

            TABPG.Controls.Add(DGV)
            TABPG.Text = "New Objects File"
            TabControl.TabPages.Add(TABPG)
            AddEventHandlers(DGV)
            Status.Text = "0 Objects Loaded!"
        Catch ex As Exception
            MsgBox("An error occured!" & vbNewLine & ex.Message, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub CloseFileToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles CloseFileToolStripMenuItem.Click
        Status.Text = Nothing
        TabControl.TabPages.Remove(TabControl.SelectedTab)
    End Sub

    Private Sub ExitToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ExitToolStripMenuItem.Click
        Application.Exit()
    End Sub

    Private Sub OpenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles OpenToolStripMenuItem.Click
        Try
            Dim openFileDialog1 As New OpenFileDialog()
            openFileDialog1.Filter = "Populous Objects Files (objs0-*.dat)|objs0-*.dat|All files (*.*)|*.*"
            openFileDialog1.FilterIndex = 0
            openFileDialog1.RestoreDirectory = True
            openFileDialog1.ShowHelp = True
            If openFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
                Try
                    Load_ObjectsInfo(openFileDialog1.FileName)
                Catch Ex As Exception
                    MessageBox.Show("Cannot read file from disk. Original error: " & Ex.Message)
                End Try
            End If
        Catch ex As Exception
            MsgBox("An error occured!" & vbNewLine & ex.Message, MsgBoxStyle.Critical)
        End Try
    End Sub

    Public Sub Load_ObjectsInfo(ByVal filepath)
        Try
            Dim reader As New BinaryReader(File.Open(filepath, FileMode.Open))
            Dim TABPG As New TabPage
            Dim DGV As New DataGridView
            Dim Objects As New List(Of ObjEditObjectsInfo)
            Dim ObjCount = 0
            While ((reader.BaseStream.Position = reader.BaseStream.Length) = False)
                Dim SingleObj As New ObjEditObjectsInfo
                SingleObj.ShapeIdx = New List(Of SByte)
                Dim object_reader As New BinaryReader(New MemoryStream(reader.ReadBytes(54))) ' Read 54 bytes
                SingleObj.flags = object_reader.ReadUInt16
                SingleObj.NumFaces = object_reader.ReadInt16
                SingleObj.NumPoints = object_reader.ReadInt16
                SingleObj.BucketOffSet = object_reader.ReadSByte
                SingleObj.SeqNum = object_reader.ReadSByte
                SingleObj.EditorScale = object_reader.ReadInt32
                SingleObj.Scale = object_reader.ReadInt32
                SingleObj.StartFace = object_reader.ReadUInt32
                SingleObj.EndFace = object_reader.ReadUInt32
                SingleObj.StartPoint = object_reader.ReadUInt32
                SingleObj.EndPoint = object_reader.ReadUInt32
                SingleObj.ScaledMinsX = object_reader.ReadInt16
                SingleObj.ScaledMinsY = object_reader.ReadInt16
                SingleObj.ScaledMinsZ = object_reader.ReadInt16
                SingleObj.ScaledMaxsX = object_reader.ReadInt16
                SingleObj.ScaledMaxsY = object_reader.ReadInt16
                SingleObj.ScaledMaxsZ = object_reader.ReadInt16
                For i As Integer = 0 To 3
                    SingleObj.ShapeIdx.Add(object_reader.ReadSByte)
                Next
                SingleObj.ScaledOffSetsX = object_reader.ReadInt16
                SingleObj.ScaledOffSetsY = object_reader.ReadInt16
                SingleObj.ScaledOffSetsZ = object_reader.ReadInt16
                ObjCount = ObjCount + 1
                Objects.Add(SingleObj)
            End While
            DGV.Dock = DockStyle.Fill
            DGV.Name = "DataGridView1"
            DGV.Columns.Add("Flags", "Flags")
            DGV.Columns.Add("NumFaces", "NumFaces")
            DGV.Columns.Add("NumPoints", "NumPoints")
            DGV.Columns.Add("BucketOffSet", "BucketOffSet")
            DGV.Columns.Add("SeqNum", "SeqNum")
            DGV.Columns.Add("EditorScale", "EditorScale")
            DGV.Columns.Add("Scale", "Scale")
            DGV.Columns.Add("StartFace", "StartFace")
            DGV.Columns.Add("EndFace", "EndFace")
            DGV.Columns.Add("StartPoint", "StartPoint")
            DGV.Columns.Add("EndPoint", "EndPoint")
            DGV.Columns.Add("ScaledMinsX", "ScaledMinsX")
            DGV.Columns.Add("ScaledMinsY", "ScaledMinsY")
            DGV.Columns.Add("ScaledMinsZ", "ScaledMinsZ")
            DGV.Columns.Add("ScaledMaxsX", "ScaledMaxsX")
            DGV.Columns.Add("ScaledMaxsY", "ScaledMaxsY")
            DGV.Columns.Add("ScaledMaxsZ", "ScaledMaxsZ")
            DGV.Columns.Add("ShapeIdx1", "ShapeIdx1")
            DGV.Columns.Add("ShapeIdx2", "ShapeIdx2")
            DGV.Columns.Add("ShapeIdx3", "ShapeIdx3")
            DGV.Columns.Add("ShapeIdx4", "ShapeIdx4")
            DGV.Columns.Add("ScaledOffSetsX", "ScaledOffSetsX")
            DGV.Columns.Add("ScaledOffSetsY", "ScaledOffSetsY")
            DGV.Columns.Add("ScaledOffSetsZ", "ScaledOffSetsZ")
            For Each obj In Objects
                DGV.Rows.Add(obj.flags, obj.NumFaces, obj.NumPoints, obj.BucketOffSet, obj.SeqNum, obj.EditorScale, _
                                obj.Scale, obj.StartFace, obj.EndFace, obj.StartPoint, obj.EndPoint, obj.ScaledMinsX, _
                                obj.ScaledMinsY, obj.ScaledMinsZ, obj.ScaledMaxsX, obj.ScaledMaxsY, obj.ScaledMaxsZ, _
                                obj.ShapeIdx(0), obj.ShapeIdx(1), obj.ShapeIdx(2), obj.ShapeIdx(3), obj.ScaledOffSetsX, _
                                obj.ScaledOffSetsY, obj.ScaledOffSetsZ)
            Next
            TABPG.Controls.Add(DGV)
            TABPG.Text = filepath
            TabControl.TabPages.Add(TABPG)
            For Each row As DataGridViewRow In DGV.Rows
                row.HeaderCell.Value = row.Index.ToString()
            Next
            DGV.RowHeadersWidth = 60
            Status.Text = ObjCount & " Objects Loaded!"
            AddEventHandlers(DGV)
            reader.Close()
        Catch ex As Exception
            MsgBox("An error occured!" & vbNewLine & ex.Message, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub ExportToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ExportToolStripMenuItem.Click
        Try
            If (TabControl.TabPages.Count > 0) Then
                If TabControl.SelectedTab.Controls.Count > 0 Then
                    Dim DataGridView1 As DataGridView = TabControl.SelectedTab.Controls(0)
                    Dim SaveDialog As New SaveFileDialog
                    SaveDialog.Title = "Save Your File"
                    SaveDialog.Filter = "XML (*.xml)|*.xml|Comma Delimited File(*.csv)|*.Csv"
                    SaveDialog.OverwritePrompt = True
                    SaveDialog.ShowHelp = True
                    If SaveDialog.ShowDialog() = DialogResult.OK Then
                        If SaveDialog.FilterIndex = 1 Then
                            ' XML
                            Dim DTB = New DataTable, RWS As Integer, CLS As Integer
                            For CLS = 0 To DataGridView1.ColumnCount - 1 ' COLUMNS OF DTB
                                DTB.Columns.Add(DataGridView1.Columns(CLS).Name.ToString)
                            Next
                            Dim DRW As DataRow
                            For RWS = 0 To DataGridView1.Rows.Count - 1 ' FILL DTB WITH DATAGRIDVIEW
                                DRW = DTB.NewRow
                                For CLS = 0 To DataGridView1.ColumnCount - 1
                                    Try
                                        DRW(DTB.Columns(CLS).ColumnName.ToString) = DataGridView1.Rows(RWS).Cells(CLS).Value.ToString
                                    Catch ex As Exception
                                    End Try
                                Next
                                DTB.Rows.Add(DRW)
                            Next
                            DTB.AcceptChanges()
                            Dim DST As New DataSet
                            DST.Tables.Add(DTB)
                            DTB.WriteXml(SaveDialog.FileName)
                        Else
                            ' CSV
                            Dim headers = (From header As DataGridViewColumn In DataGridView1.Columns.Cast(Of DataGridViewColumn)() _
        Select header.HeaderText).ToArray
                            Dim rows = From row As DataGridViewRow In DataGridView1.Rows.Cast(Of DataGridViewRow)() _
                                        Where Not row.IsNewRow _
                                        Select Array.ConvertAll(row.Cells.Cast(Of DataGridViewCell).ToArray, Function(c) If(c.Value IsNot Nothing, c.Value.ToString, ""))
                            Using sw As New IO.StreamWriter(SaveDialog.FileName)
                                sw.WriteLine(String.Join(",", headers))
                                For Each r In rows
                                    sw.WriteLine(String.Join(",", r))
                                Next
                            End Using
                        End If
                    End If
                End If
            End If
        Catch ex As Exception
            MsgBox("An error occured!" & vbNewLine & ex.Message, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub ImportToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ImportToolStripMenuItem.Click
        Try
            NewToolStripMenuItem.PerformClick()
            If (TabControl.TabPages.Count > 0) Then
                If TabControl.SelectedTab.Controls.Count > 0 Then
                    Dim DataGridView1 As DataGridView = TabControl.SelectedTab.Controls(0)
                    DataGridView1.Columns.Clear()
                    Dim OpenDialog As New OpenFileDialog
                    OpenDialog.Title = "Open Your File"
                    OpenDialog.Filter = "XML (*.xml)|*.xml|Comma Delimited File(*.csv)|*.Csv"
                    If OpenDialog.ShowDialog() = DialogResult.OK Then
                        If OpenDialog.FilterIndex = 1 Then
                            Dim xmlFile As XmlReader
                            xmlFile = XmlReader.Create(OpenDialog.FileName, New XmlReaderSettings())
                            Dim ds As New DataSet
                            ds.ReadXml(xmlFile)
                            If Not ds.Tables(0).Columns.Count = 24 Then
                                MsgBox("Invalid XML File!", MsgBoxStyle.Information)
                            Else
                                DataGridView1.DataSource = ds.Tables(0)
                                Status.Text = DataGridView1.Rows.Count & " Objects Loaded!"
                            End If
                        Else
                            Dim sr As New IO.StreamReader(OpenDialog.FileName)
                            Dim dt As New DataTable
                            Dim newline() As String = sr.ReadLine.Split(","c)
                            dt.Columns.AddRange({New DataColumn(newline(0)), New DataColumn(newline(1)), _
                                                    New DataColumn(newline(2)), New DataColumn(newline(3)), _
                                                    New DataColumn(newline(4)), New DataColumn(newline(5)), _
                                                    New DataColumn(newline(6)), New DataColumn(newline(7)), _
                                                    New DataColumn(newline(8)), New DataColumn(newline(9)), _
                                                    New DataColumn(newline(10)), New DataColumn(newline(11)), _
                                                    New DataColumn(newline(12)), New DataColumn(newline(13)), _
                                                    New DataColumn(newline(14)), New DataColumn(newline(15)), _
                                                    New DataColumn(newline(16)), New DataColumn(newline(17)), _
                                                    New DataColumn(newline(18)), New DataColumn(newline(19)), _
                                                    New DataColumn(newline(20)), New DataColumn(newline(21)), _
                                                    New DataColumn(newline(22)), New DataColumn(newline(23))})
                            While (Not sr.EndOfStream)
                                newline = sr.ReadLine.Split(","c)
                                Dim newrow As DataRow = dt.NewRow
                                newrow.ItemArray = {newline(0), newline(1), newline(2), _
                                                    newline(3), newline(4), newline(5), _
                                                    newline(6), newline(7), newline(8), _
                                                    newline(9), newline(10), newline(11), _
                                                    newline(12), newline(13), newline(14), _
                                                    newline(15), newline(16), newline(17), _
                                                    newline(18), newline(19), newline(20), _
                                                    newline(21), newline(22), newline(23)}
                                dt.Rows.Add(newrow)
                            End While
                            DataGridView1.DataSource = dt
                            For Each row As DataGridViewRow In DataGridView1.Rows
                                row.HeaderCell.Value = row.Index.ToString()
                            Next
                            DataGridView1.RowHeadersWidth = 60
                            AddEventHandlers(DataGridView1)
                            Status.Text = DataGridView1.Rows.Count & " Objects Loaded!"
                        End If
                    End If
                End If
            End If
        Catch ex As Exception
            MsgBox("An error occured!" & vbNewLine & ex.Message, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub SaveToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SaveToolStripMenuItem.Click
        Try
            If (TabControl.TabPages.Count > 0) Then
                If TabControl.SelectedTab.Controls.Count > 0 Then
                    Dim DataGridView1 As DataGridView = TabControl.SelectedTab.Controls(0)
                    If Not TabControl.SelectedTab.Text = "New Objects File" Then
                        SaveObjectsFile(TabControl.SelectedTab.Text)
                    Else
                        SaveAsToolStripMenuItem.PerformClick()
                    End If
                End If
            End If
        Catch ex As Exception
            MsgBox("An error occured!" & vbNewLine & ex.Message, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub SaveAsToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SaveAsToolStripMenuItem.Click
        Try
            If (TabControl.TabPages.Count > 0) Then
                If TabControl.SelectedTab.Controls.Count > 0 Then
                    Dim DataGridView1 As DataGridView = TabControl.SelectedTab.Controls(0)
                    Dim SaveDialog As New SaveFileDialog
                    SaveDialog.ShowHelp = True
                    SaveDialog.Title = "Save Your File"
                    SaveDialog.Filter = "Populous Objects Files (objs0-*.dat)|objs0-*.dat|All files (*.*)|*.*"
                    SaveDialog.OverwritePrompt = True
                    If SaveDialog.ShowDialog() = DialogResult.OK Then
                        SaveObjectsFile(SaveDialog.FileName)
                        TabControl.SelectedTab.Text = SaveDialog.FileName
                    End If
                End If
            End If
        Catch ex As Exception
            MsgBox("An error occured!" & vbNewLine & ex.Message, MsgBoxStyle.Critical)
        End Try
    End Sub

    Public Sub SaveObjectsFile(ByVal filepath)
        Try
            If My.Computer.FileSystem.FileExists(filepath) Then
                Kill(filepath)
            End If
            Dim objects As New List(Of ObjEditObjectsInfo)
            Dim DataGridView1 As DataGridView = TabControl.SelectedTab.Controls(0)
            For r As Integer = 0 To (DataGridView1.Rows.Count - 2)
                Dim x = DataGridView1.Columns.Count
                Dim SingleObj As New ObjEditObjectsInfo
                SingleObj.ShapeIdx = New List(Of SByte)
                SingleObj.flags = (DataGridView1.Item(0, r).Value)
                SingleObj.NumFaces = (DataGridView1.Item(1, r).Value)
                SingleObj.NumPoints = (DataGridView1.Item(2, r).Value)
                SingleObj.BucketOffSet = (DataGridView1.Item(3, r).Value)
                SingleObj.SeqNum = (DataGridView1.Item(4, r).Value)
                SingleObj.EditorScale = (DataGridView1.Item(5, r).Value)
                SingleObj.Scale = (DataGridView1.Item(6, r).Value)
                SingleObj.StartFace = (DataGridView1.Item(7, r).Value)
                SingleObj.EndFace = (DataGridView1.Item(8, r).Value)
                SingleObj.StartPoint = (DataGridView1.Item(9, r).Value)
                SingleObj.EndPoint = (DataGridView1.Item(10, r).Value)

                SingleObj.ScaledMinsX = (DataGridView1.Item(11, r).Value)
                SingleObj.ScaledMinsY = (DataGridView1.Item(12, r).Value)
                SingleObj.ScaledMinsZ = (DataGridView1.Item(13, r).Value)

                SingleObj.ScaledMaxsX = (DataGridView1.Item(14, r).Value)
                SingleObj.ScaledMaxsY = (DataGridView1.Item(15, r).Value)
                SingleObj.ScaledMaxsZ = (DataGridView1.Item(16, r).Value)

                For i As Integer = 0 To 3
                    SingleObj.ShapeIdx.Add(DataGridView1.Item(17 + i, r).Value)
                Next

                SingleObj.ScaledOffSetsX = (DataGridView1.Item(21, r).Value)
                SingleObj.ScaledOffSetsY = (DataGridView1.Item(22, r).Value)
                SingleObj.ScaledOffSetsZ = (DataGridView1.Item(23, r).Value)
                objects.Add(SingleObj)
            Next
            Using writer As BinaryWriter = New BinaryWriter(File.Open(filepath, FileMode.Create))
                For Each obj In objects
                    writer.Write(Convert.ToUInt16(obj.flags))

                    writer.Write(Convert.ToInt16(obj.NumFaces))
                    writer.Write(Convert.ToInt16(obj.NumPoints))

                    writer.Write(Convert.ToSByte(obj.BucketOffSet))
                    writer.Write(Convert.ToSByte(obj.SeqNum))

                    writer.Write(Convert.ToInt32(obj.EditorScale))
                    writer.Write(Convert.ToInt32(obj.Scale))

                    writer.Write(Convert.ToUInt32(obj.StartFace))
                    writer.Write(Convert.ToUInt32(obj.EndFace))
                    writer.Write(Convert.ToUInt32(obj.StartPoint))
                    writer.Write(Convert.ToUInt32(obj.EndPoint))

                    writer.Write(Convert.ToInt16(obj.ScaledMinsX))
                    writer.Write(Convert.ToInt16(obj.ScaledMinsY))
                    writer.Write(Convert.ToInt16(obj.ScaledMinsZ))

                    writer.Write(Convert.ToInt16(obj.ScaledMaxsX))
                    writer.Write(Convert.ToInt16(obj.ScaledMaxsY))
                    writer.Write(Convert.ToInt16(obj.ScaledMaxsZ))

                    For i As Integer = 0 To 3
                        writer.Write(Convert.ToSByte(obj.ShapeIdx(i)))
                    Next

                    writer.Write(Convert.ToInt16(obj.ScaledOffSetsX))
                    writer.Write(Convert.ToInt16(obj.ScaledOffSetsY))
                    writer.Write(Convert.ToInt16(obj.ScaledOffSetsZ))
                Next
            End Using
        Catch ex As Exception
            MsgBox("An error occured!" & vbNewLine & ex.Message, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub AboutToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AboutToolStripMenuItem.Click
        MsgBox("Created By Brandan Tyler Lasley 2014")
    End Sub

    Private Sub AddEventHandlers(ByVal DGV As DataGridView)
        AddHandler DGV.RowsAdded, AddressOf RowsAdded
        AddHandler DGV.RowsRemoved, AddressOf RowsRemoved
        AddHandler DGV.CellMouseClick, AddressOf CellMouseClick
    End Sub

    Private Sub RowsAdded(sender As Object, e As System.Windows.Forms.DataGridViewRowsAddedEventArgs)
        Dim DGV As DataGridView = TabControl.SelectedTab.Controls(0)
        For Each row As DataGridViewRow In DGV.Rows
            row.HeaderCell.Value = row.Index.ToString()
        Next
        DGV.RowHeadersWidth = 60
    End Sub

    Private Sub RowsRemoved(sender As Object, e As System.Windows.Forms.DataGridViewRowsRemovedEventArgs)
        Dim DGV As DataGridView = TabControl.SelectedTab.Controls(0)
        For Each row As DataGridViewRow In DGV.Rows
            row.HeaderCell.Value = row.Index.ToString()
        Next
        DGV.RowHeadersWidth = 60
    End Sub

    Private Sub CellMouseClick(sender As Object, e As System.Windows.Forms.DataGridViewCellMouseEventArgs)
        Position.Text = "Row: " & e.RowIndex & " Column: " & e.ColumnIndex
    End Sub

End Class
